Index: /stable/HeuristicLab.Clients.OKB/3.3/RunCreation/OKBSolution.cs
===================================================================
--- /stable/HeuristicLab.Clients.OKB/3.3/RunCreation/OKBSolution.cs	(revision 15082)
+++ /stable/HeuristicLab.Clients.OKB/3.3/RunCreation/OKBSolution.cs	(revision 15082)
@@ -0,0 +1,90 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2016 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using System;
+
+namespace HeuristicLab.Clients.OKB.RunCreation {
+  [Item("OKB Solution", "")]
+  [StorableClass]
+  public abstract class OKBSolution : Item {
+    [Storable]
+    private long problemId;
+    public long ProblemId {
+      get { return problemId; }
+      protected set { problemId = value; }
+    }
+
+    [Storable]
+    private long solutionId;
+    public long SolutionId {
+      get { return solutionId; }
+      protected set { solutionId = value; }
+    }
+    
+    [Storable]
+    private IItem solution;
+    public IItem Solution {
+      get { return solution; }
+      set {
+        if (solution == value) return;
+        solution = value;
+        OnSolutionChanged();
+      }
+    }
+
+    [StorableConstructor]
+    protected OKBSolution(bool deserializing) : base(deserializing) { }
+    protected OKBSolution(OKBSolution original, Cloner cloner)
+      : base(original, cloner) {
+      problemId = original.problemId;
+      solutionId = original.solutionId;
+      solution = cloner.Clone(original.solution);
+    }
+    protected OKBSolution(long problemId) {
+      this.problemId = problemId;
+      solutionId = -1;
+      solution = null;
+    }
+    protected OKBSolution(Solution sol) {
+      problemId = sol.ProblemId;
+      solutionId = sol.Id;
+    }
+
+    public abstract void Download(long solutionId);
+    public abstract void DownloadData();
+
+    public abstract void Upload();
+
+    public static OKBSolution Convert(Solution solution) {
+      if (solution is SingleObjectiveSolution) return new SingleObjectiveOKBSolution(solution);
+      throw new ArgumentException("Unknown solution type", "solution");
+    }
+
+    public event EventHandler SolutionChanged;
+    private void OnSolutionChanged() {
+      var handler = SolutionChanged;
+      if (handler != null) handler(this, EventArgs.Empty);
+    }
+  }
+}
Index: /stable/HeuristicLab.Clients.OKB/3.3/RunCreation/RunCreationClient.cs
===================================================================
--- /stable/HeuristicLab.Clients.OKB/3.3/RunCreation/RunCreationClient.cs	(revision 15081)
+++ /stable/HeuristicLab.Clients.OKB/3.3/RunCreation/RunCreationClient.cs	(revision 15082)
@@ -20,8 +20,4 @@
 #endregion
 
-using System;
-using System.Collections.Generic;
-using System.IO;
-using System.Linq;
 using HeuristicLab.Clients.Common;
 using HeuristicLab.Common;
@@ -29,4 +25,8 @@
 using HeuristicLab.Data;
 using HeuristicLab.Persistence.Default.Xml;
+using System;
+using System.Collections.Generic;
+using System.IO;
+using System.Linq;
 
 namespace HeuristicLab.Clients.OKB.RunCreation {
@@ -86,5 +86,5 @@
 
     #region Algorithm Methods
-    public static byte[] GetAlgorithmData(long algorithmId) {
+    public byte[] GetAlgorithmData(long algorithmId) {
       return CallRunCreationService<byte[]>(s => s.GetAlgorithmData(algorithmId));
     }
@@ -92,6 +92,28 @@
 
     #region Problem Methods
-    public static byte[] GetProblemData(long problemId) {
+    public byte[] GetProblemData(long problemId) {
       return CallRunCreationService<byte[]>(s => s.GetProblemData(problemId));
+    }
+    #endregion
+
+    #region Solution Methods
+    public IEnumerable<Solution> GetSolutions(long problemId) {
+      return CallRunCreationService(s => s.GetSolutions(problemId));
+    }
+
+    public Solution GetSolution(long solutionId) {
+      return CallRunCreationService(s => s.GetSolution(solutionId));
+    }
+
+    public byte[] GetSolutionData(long solutionId) {
+      return CallRunCreationService(s => s.GetSolutionData(solutionId));
+    }
+
+    public long AddSolution(Solution solution, byte[] data) {
+      return CallRunCreationService(s => s.AddSolution(solution, data));
+    }
+
+    public void DeleteSolution(Solution solution) {
+      CallRunCreationService(s => s.DeleteSolution(solution));
     }
     #endregion
@@ -104,13 +126,13 @@
 
     #region Characteristic Methods
-    public static IEnumerable<Value> GetCharacteristicValues(long problemId) {
+    public IEnumerable<Value> GetCharacteristicValues(long problemId) {
       return CallRunCreationService(s => s.GetCharacteristicValues(problemId));
     }
 
-    public static void SetCharacteristicValue(long problemId, Value v) {
+    public void SetCharacteristicValue(long problemId, Value v) {
       CallRunCreationService(s => s.SetCharacteristicValue(problemId, v));
     }
 
-    public static void SetCharacteristicValues(long problemId, IEnumerable<Value> values) {
+    public void SetCharacteristicValues(long problemId, IEnumerable<Value> values) {
       CallRunCreationService(s => s.SetCharacteristicValues(problemId, values.ToList()));
     }
@@ -208,5 +230,5 @@
 
     #region Helpers
-    private static void CallRunCreationService(Action<IRunCreationService> call) {
+    private void CallRunCreationService(Action<IRunCreationService> call) {
       RunCreationServiceClient client = ClientFactory.CreateClient<RunCreationServiceClient, IRunCreationService>();
       try {
@@ -220,5 +242,5 @@
       }
     }
-    private static T CallRunCreationService<T>(Func<IRunCreationService, T> call) {
+    private T CallRunCreationService<T>(Func<IRunCreationService, T> call) {
       RunCreationServiceClient client = ClientFactory.CreateClient<RunCreationServiceClient, IRunCreationService>();
       try {
Index: /stable/HeuristicLab.Clients.OKB/3.3/RunCreation/SingleObjectiveOKBSolution.cs
===================================================================
--- /stable/HeuristicLab.Clients.OKB/3.3/RunCreation/SingleObjectiveOKBSolution.cs	(revision 15082)
+++ /stable/HeuristicLab.Clients.OKB/3.3/RunCreation/SingleObjectiveOKBSolution.cs	(revision 15082)
@@ -0,0 +1,105 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2016 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HeuristicLab.Persistence.Default.Xml;
+using System;
+using System.IO;
+
+namespace HeuristicLab.Clients.OKB.RunCreation {
+  [Item("OKB Solution (single-objective)", "")]
+  [StorableClass]
+  public sealed class SingleObjectiveOKBSolution : OKBSolution {
+    [Storable]
+    private double quality;
+    public double Quality {
+      get { return quality; }
+      set {
+        if (quality == value) return;
+        quality = value;
+        OnQualityChanged();
+      }
+    }
+
+    [StorableConstructor]
+    private SingleObjectiveOKBSolution(bool deserializing) : base(deserializing) { }
+    private SingleObjectiveOKBSolution(SingleObjectiveOKBSolution original, Cloner cloner)
+      : base(original, cloner) {
+      quality = original.quality;
+    }
+    public SingleObjectiveOKBSolution(long problemId) : base(problemId) {
+      quality = double.NaN;
+    }
+    public SingleObjectiveOKBSolution(Solution solution) : base(solution) {
+      var soSolution = solution as SingleObjectiveSolution;
+      if (soSolution == null) throw new ArgumentException("Solution is not of type SingleObjectiveSolution", "solution");
+      Quality = soSolution.Quality;
+    }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new SingleObjectiveOKBSolution(this, cloner);
+    }
+
+    public override void Download(long solutionId) {
+      if (SolutionId == solutionId) return;
+      byte[] solutionData = RunCreationClient.Instance.GetSolutionData(solutionId);
+      using (var stream = new MemoryStream(solutionData)) {
+        Solution = XmlParser.Deserialize<IItem>(stream);
+        SolutionId = solutionId;
+      }
+      var sol = RunCreationClient.Instance.GetSolution(solutionId);
+      ProblemId = sol.ProblemId;
+      var soSol = sol as SingleObjectiveSolution;
+      if (soSol == null) throw new InvalidOperationException(string.Format("Solution with id {0} is not a single-objective solution.", solutionId));
+      Quality = soSol.Quality;
+    }
+
+    public override void DownloadData() {
+      using (var stream = new MemoryStream(RunCreationClient.Instance.GetSolutionData(SolutionId))) {
+        Solution = XmlParser.Deserialize<IItem>(stream);
+      }
+    }
+
+    public override void Upload() {
+      if (SolutionId != -1) throw new InvalidOperationException("Solution exists already.");
+      using (var stream = new MemoryStream()) {
+        if (Solution != null) XmlGenerator.Serialize(Solution, stream);
+        SolutionId = RunCreationClient.Instance.AddSolution(
+          new SingleObjectiveSolution() {
+            ProblemId = ProblemId,
+            Quality = Quality,
+            DataType = Solution != null ? new DataType() {
+              Name = Solution.GetType().Name,
+              TypeName = Solution.GetType().FullName
+            } : null
+          }, stream.ToArray());
+      }
+    }
+
+    public event EventHandler QualityChanged;
+    private void OnQualityChanged() {
+      var handler = QualityChanged;
+      if  (handler != null) handler(this, EventArgs.Empty);
+    }
+  }
+}
Index: /stable/HeuristicLab.Services.OKB.DataAccess/3.3/OKB.dbml
===================================================================
--- /stable/HeuristicLab.Services.OKB.DataAccess/3.3/OKB.dbml	(revision 15081)
+++ /stable/HeuristicLab.Services.OKB.DataAccess/3.3/OKB.dbml	(revision 15082)
@@ -49,4 +49,5 @@
       <Association Name="DataType_Value" Member="Values" ThisKey="Id" OtherKey="DataTypeId" Type="Value" />
       <Association Name="DataType_CharacteristicValue" Member="CharacteristicValues" ThisKey="Id" OtherKey="DataTypeId" Type="CharacteristicValue" />
+      <Association Name="DataType_SingleObjectiveSolution" Member="SingleObjectiveSolutions" ThisKey="Id" OtherKey="DataTypeId" Type="SingleObjectiveSolution" />
     </Type>
   </Table>
@@ -89,4 +90,5 @@
       <Association Name="Problem_Run" Member="Runs" ThisKey="Id" OtherKey="ProblemId" Type="Run" />
       <Association Name="Problem_CharacteristicValue" Member="CharacteristicValues" ThisKey="Id" OtherKey="ProblemId" Type="CharacteristicValue" />
+      <Association Name="Problem_SingleObjectiveSolution" Member="SingleObjectiveSolutions" ThisKey="Id" OtherKey="ProblemId" Type="SingleObjectiveSolution" />
       <Association Name="DataType_Problem" Member="DataType" ThisKey="DataTypeId" OtherKey="Id" Type="DataType" IsForeignKey="true" />
       <Association Name="Platform_Problem" Member="Platform" ThisKey="PlatformId" OtherKey="Id" Type="Platform" IsForeignKey="true" />
@@ -103,4 +105,5 @@
       <Association Name="BinaryData_Problem" Member="Problems" ThisKey="Id" OtherKey="BinaryDataId" Type="Problem" />
       <Association Name="BinaryData_Value" Member="Values" ThisKey="Id" OtherKey="BinaryDataId" Type="Value" />
+      <Association Name="BinaryData_SingleObjectiveSolution" Member="SingleObjectiveSolutions" ThisKey="Id" OtherKey="BinaryDataId" Type="SingleObjectiveSolution" />
     </Type>
   </Table>
@@ -114,4 +117,5 @@
       <Column Name="ClientId" Type="System.Guid" DbType="UniqueIdentifier NOT NULL" CanBeNull="false" />
       <Association Name="Run_Value" Member="Values" ThisKey="Id" OtherKey="RunId" Type="Value" />
+      <Association Name="Run_SingleObjectiveSolution" Member="SingleObjectiveSolutions" ThisKey="Id" OtherKey="RunId" Type="SingleObjectiveSolution" />
       <Association Name="Algorithm_Run" Member="Algorithm" ThisKey="AlgorithmId" OtherKey="Id" Type="Algorithm" IsForeignKey="true" />
       <Association Name="Problem_Run" Member="Problem" ThisKey="ProblemId" OtherKey="Id" Type="Problem" IsForeignKey="true" />
@@ -162,3 +166,17 @@
     </Type>
   </Table>
+  <Table Name="dbo.SingleObjectiveSolution" Member="SingleObjectiveSolutions">
+    <Type Name="SingleObjectiveSolution">
+      <Column Name="Id" Type="System.Int64" DbType="BigInt NOT NULL IDENTITY" IsPrimaryKey="true" IsDbGenerated="true" CanBeNull="false" />
+      <Column Name="ProblemId" Type="System.Int64" DbType="BigInt" CanBeNull="true" />
+      <Column Name="BinaryDataId" Type="System.Int64" DbType="BigInt" CanBeNull="true" />
+      <Column Name="RunId" Type="System.Int64" DbType="BigInt" CanBeNull="true" />
+      <Column Name="Quality" Type="System.Double" DbType="Float" CanBeNull="false" />
+      <Column Name="DataTypeId" Type="System.Int64" DbType="BigInt" CanBeNull="true" />
+      <Association Name="Problem_SingleObjectiveSolution" Member="Problem" ThisKey="ProblemId" OtherKey="Id" Type="Problem" IsForeignKey="true" />
+      <Association Name="BinaryData_SingleObjectiveSolution" Member="BinaryData" ThisKey="BinaryDataId" OtherKey="Id" Type="BinaryData" IsForeignKey="true" />
+      <Association Name="Run_SingleObjectiveSolution" Member="Run" ThisKey="RunId" OtherKey="Id" Type="Run" IsForeignKey="true" />
+      <Association Name="DataType_SingleObjectiveSolution" Member="DataType" ThisKey="DataTypeId" OtherKey="Id" Type="DataType" IsForeignKey="true" />
+    </Type>
+  </Table>
 </Database>
